leetcode_Find All Numbers Disappeared in an Array

Given an array of integers where 1 ≤ a[i] ≤ n (n = size of array), some elements appear twice and others appear once.

Find all the elements of [1, n] inclusive that do not appear in this array.

Could you do it without extra space and in O(n) runtime? You may assume the returned list does not count as extra space.

Example:

Input:
[4,3,2,7,8,2,3,1]

Output:
[5,6]

思路1:哈希,时间复杂度O(n),空间复杂度O(n)

class Solution1 {
    public List<Integer> findDisappearedNumbers(int[] nums) {
        List<Integer> result = new ArrayList<Integer>();
        int[] hash = new int[nums.length+1];
        for(int i = 0; i < hash.length; ++i)
        {
            hash[i] = 0;
        }
        for(int i = 0; i < nums.length; ++i)
        {
            hash[nums[i]] = 1;
        }
        for(int i = 1; i < hash.length; ++i)
        {
            if(hash[i] == 0)
                result.add(i);
        }
        return result;
    }
}

由于题目说最好是能够O(1)的空间复杂度,因此优化算法的时候需要将输入的数组当成哈希表来处理。

思路2:用nums当做一个哈希表,当一个数字首次a出现时,将该数字a应该在哈希表中出现的位置中的值b置为-b,即用负数来标记a已存在,原理如思路1中哈希表的置1操作,最后哈希表中值为正数的坑所代表的数为缺少的数。时间复杂度O(n),空间复杂度O(1)

class Solution2 {
    public List<Integer> findDisappearedNumbers(int[] nums) {
        List<Integer> result = new ArrayList<Integer>();
        for(int i = 0; i< nums.length; ++i)
        {
            int j = Math.abs(nums[i])-1;        //值经过标记后可能为负数,而且索引从0开始,而不是1
            if(nums[j] > 0)
                nums[j] = -nums[j];
        }
        for(int i = 0; i < nums.length; ++i)
            if(nums[i] > 0)
                result.add(i+1);
        return result;
    }
}
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

alw_123

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值